angular.module('focaModalMoneda')
    .controller('focaModalMonedaController', 
        [
            '$filter',
            '$scope',
            '$uibModalInstance',
            'focaModalMonedaService',
            function($filter, $scope, $uibModalInstance, focaModalMonedaService) {
                focaModalMonedaService.getMonedas().then(
                    function(res) {
                        $scope.moneda = res.data;
                        $scope.search();
                    }
                );

                // pagination
                $scope.numPerPage = 10;
                $scope.currentPage = 1;
                $scope.filteredMoneda = [];
                $scope.currentPageMoneda = [];
                $scope.selectedMoneda = -1;
                
                //METODOS
                $scope.search = function() {
                    $scope.filteredMoneda = $filter('filter')(
                        $scope.moneda, 
                        {$: $scope.filters}
                    );

                    $scope.lastPage = Math.ceil(
                        $scope.filteredMoneda.length / $scope.numPerPage
                    );

                    $scope.resetPage();
                };

                $scope.resetPage = function() {
                    $scope.currentPage = 1;
                    $scope.selectPage(1);
                };

                $scope.selectPage = function(page) {
                    var start = (page - 1) * $scope.numPerPage;
                    var end = start + $scope.numPerPage;
                    $scope.paginas = [];
                    $scope.paginas = calcularPages(page);
                    $scope.currentPageMoneda = 
                        $scope.filteredMoneda.slice(start, end);
                    $scope.currentPage = page;
                };

                $scope.select = function(moneda) {
                    $uibModalInstance.close(moneda);
                };

                $scope.cancel = function() {
                    $uibModalInstance.dismiss('cancel');
                };

                $scope.busquedaDown = function(key) {
                    if (key === 40) {
                        primera(key);
                    }
                };

                $scope.busquedaPress = function(key) {
                    if (key === 13) {
                        primera(key);
                    }
                };

                $scope.itemProducto = function(key) {
                    if (key === 38) {
                        anterior(key);
                    }

                    if (key === 40) {
                        siguiente(key);
                    }

                    if (key === 37) {
                        retrocederPagina();
                    }

                    if (key === 39) {
                        avanzarPagina();
                    }
                };

                function calcularPages(paginaActual) {
                    var paginas = [];
                    paginas.push(paginaActual);

                    if (paginaActual - 1 > 1) {
                        
                        paginas.unshift(paginaActual - 1);
                        if (paginaActual - 2 > 1) {
                            paginas.unshift(paginaActual - 2);
                        }
                    }

                    if (paginaActual + 1 < $scope.lastPage) {
                        paginas.push(paginaActual + 1);
                        if (paginaActual + 2 < $scope.lastPage) {
                            paginas.push(paginaActual + 2);
                        }
                    }

                    if (paginaActual !== 1) {
                        paginas.unshift(1);
                    }

                    if (paginaActual !== $scope.lastPage) {
                        paginas.push($scope.lastPage);
                    }

                    return paginas;
                }

                function primera() {
                    $scope.selectedMoneda = 0;
                }

                function anterior() {
                    if ($scope.selectedMoneda === 0 && $scope.currentPage > 1) {
                        retrocederPagina();
                    } else {
                        $scope.selectedMoneda--;
                    }
                }

                function siguiente() {
                    if ($scope.selectedMoneda <
                            $scope.currentPageMoneda.length - 1 ) {
                        $scope.selectedMoneda++;
                    } else {
                            avanzarPagina();
                    }
                }

                function retrocederPagina() {
                    if ($scope.currentPage > 1) {
                        $scope.selectPage($scope.currentPage - 1);
                        $scope.selectedMoneda = $scope.numPerPage - 1;
                    }
                }

                function avanzarPagina() {
                    if ($scope.currentPage < $scope.lastPage) {
                        $scope.selectPage($scope.currentPage + 1);
                        $scope.selectedMoneda = 0;
                    }
                }
            }
        ]
    );
